/** Peter Bergström - 2014 */
PB = {
	showingContact: false,
	showingContent: false,
	showContactModal: function() {
		$("#contact-form")[0].reset();
		$('.contact').removeClass('hidden').addClass('show');
		this.showingContact = true;
		return true;
	},
	hideContactModal: function() {
		$('.contact').addClass('hidden').removeClass('show');
		this.showingContact = false;
		$("#contact-form")[0].reset();
		$("#contact-form").removeClass();
		return true;
	},
	showSiteContentModal: function(k) {
		var ret = false;
		if (this.content[k]) {
			$('.site-content').html(this.content[k].join('')).addClass('show').removeClass('hidden');
			this.showingContent = true;
			ret = true;
		}
		return ret;
	},
	hideSiteContentModal: function() {
		$('.site-content').addClass('hidden').removeClass('show');
		this.showingContent = false;
		return true;
	},
	showModal: function(r,sr) {
		var isShowing = false;
		if (r == 'contact') {
			isShowing = this.showContactModal();
		} else if (r) {
			isShowing = this.showSiteContentModal(r);
		}
		if (isShowing) {
			$('body').addClass('showing-modal');
			var sC = $('.site-content');
			if(sr) {
			  setTimeout(function() {
			    var o = ($(('#'+r+'_'+sr)).offset().top);
          if(isMobile()) {
    			  window.scrollTo(0, o-50);
          } else {
    			  sC.scrollTop(o-100);
          }
			  }, 200);
			} else {
			  sC.scrollTop(0);
			}
			if(!isMobile()) {
			  window.scrollTo(0, 0);
		  }
		}
	},
	closeModal: function() {
		if (this.showingContact) {
			this.hideContactModal();
		}
		if (this.showSiteContentModal) {
			this.hideSiteContentModal();
		}
		this.clearRoute();
		$('body').removeClass('showing-modal');
	},
	processEmailAndSendIfPossible: function() {
		$("#contact-form").removeClass();
		setTimeout(function() {
			var fields = $("#contact-form").find('input[type=text], textarea'),
				vals = {},
				hasErrors = false;
			fields.each(function(i, f) {
				var v = f.value,
					n = f.name,
					errorClass = 'error-no-' + n,
					hasErrorForField = (v == f.placeholder || v == '');
				if (name == 'email' && !hasErrorForField) {
					var emailRegex = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
					hasErrorForField = !emailRegex.test(v);
				}
				if (hasErrorForField) {
					$("#contact-form").addClass(errorClass);
					hasErrors = true;
				} else {
					$("#contact-form").removeClass(errorClass);
				}
				vals[n] = v;
			});
			if (!hasErrors) {
				$.ajax({
					url: "email.php",
					type: "POST",
					data: vals,
					success: function() {
						PB.closeModal();
					},
					error: function(r, o, e) {
						var rB = $.parseJSON(r.responseText);
						if (r.status == 400) {
							var errs = rb.errors;
							for (var i = 0; i < errs.length; i++) {
								$("#contact-form").addClass('error-no-' + errs[i]);
							}
						} else {
							$("#contact-form").addClass('error-500');
						}
					}
				});
			}
		},
		200);
	},
	browserCompatability: function() {
		if (!Modernizr.input.placeholder) {
		  $('html').addClass('no-placeholder-support');
		}
	},
	routeToPermalinkIfNeeded: function() {
		var h = document.location.hash,
		    c = h.split('/');
		if (c.length) {
			var r = c[0].replace('#', '')
			    sr = null;
			if (r == '') {
				ga('send', 'event', 'route', 'close');
				this.closeModal();
			} else {
				ga('send', 'event', 'route', h);
				if(c && c[1]) {
				  sr = c[1];
				}
				this.showModal(r,sr);
			}
		}
	},
	clearRoute: function() {
		document.location.hash = "";
	},
	init: function() {
		$("#contact-form").submit(function(ev) {
			PB.processEmailAndSendIfPossible();
			ev.preventDefault();
			return true;
		});
		this.browserCompatability();
		$(window).on('hashchange', function() {
			PB.routeToPermalinkIfNeeded();
		});
		PB.routeToPermalinkIfNeeded();
		if (isMobile()) {
			resizeOverlay();
			$('html').removeClass('loading').addClass('loaded');
		}
	},
  content:{
     thoughts:[
        '<h1 class="site-content-main-title">Thoughts</h1>',
        '<div class="content-group">',
        ' <div class="content-item">',
        '    <h3 id="elsa">Elsa</h3>',
        '    <div class="content-item-date">Wednesday, March 26, 2014 - <a href="http://www.peterbergstrom.com#thoughts/elsa" title="permalink" target="_blank">[permalink]</a></div>',
        '    <div class="content-item-text">',
        '       <p>On March 4th, 2014 my life changed forever when our daughter, Elsa, was born. It\'s amazing how quickly your life priorities shift and evolve, all for the better. Tracy and I were really happy to welcome Elsa to the world. She just came home last week after 18 days in the NICU. Now, she is thriving and making our lives fuller every day.</p>',
        '       <p style="text-align:center;"><img src="images/elsa.jpg"</p>',
        '    </div>',
        ' </div>',
        '<div class="content-group">',
        ' <div class="content-item">',
        '    <h3 id="thoughts_ios-development-panel-discussion-at-apps-world">iOS Development Panel Discussion At Apps World</h3>',
        '    <div class="content-item-date">Tuesday, February 4, 2014 - <a href="http://www.peterbergstrom.com#thoughts/ios-development-panel-discussion-at-apps-world" title="permalink" target="_blank">[permalink]</a></div>',
        '    <div class="content-item-text">',
        '       <p>This Thursday at 2PM, I\'ll be participating in a panel discussion on iOS development at Apps World. The panel is "Getting the Most From Apple\'s Walled Garden." It should be an interesting discussion giving advice on how to work within Apple\'s constructs and application approval process. Furthermore, we\'ll be talking about the benefits and caveats of using third party libraries and APIs, and how to manage your application development after launch to ensure continued stability.</p>',
        '       <p>I also hope to share some insights that I\'ve gotten from developing and leading the engineering of the Groupon iPhone and iPad apps over the past year and a half. During that time, I\'ve seen the Groupon app grow to be one of the most popular apps in the Apple App store and have become central to Groupon\'s success.</p>',
        '       <p>For more information, check out the <a href="http://www.apps-world.net/northamerica/agenda/tracks/developer-world" target="_blank">agenda</a> for the Developer World track at the conference. Come check it out at 2PM on Thursday, February 4th, 2014!</p>',
        '    </div>',
        ' </div>',
        '<div class="content-group">',
        ' <div class="content-item">',
        '    <h3 id="thoughts_site-redesigned">Site Redesigned</h3>',
        '    <div class="content-item-date">Saturday, January 25, 2014 - <a href="http://www.peterbergstrom.com#thoughts/site-redesigned" title="permalink" target="_blank">[permalink]</a></div>',
        '    <div class="content-item-text">',
        '       <p>Welcome to the new site! I\'ve redesigned the site from the ground up with both desktop and mobile versions. The background image is central to the one page site because it has grown to be special to me. I took it on a particularly good bike ride up Montebello Road a couple of years ago and it has been my background image on my phone since then. Since I see it so often and it is one of my favorite images that I have taken, I thought that I\'d share it with the world here as part of this site.</p>',
        '       <p>Check out the new site and enjoy!</p>',
        '    </div>',
        ' </div>',
        ' <div class="content-item">',
        '    <h3 id="thoughts_two-years-ago">Two Years Ago Today</h3>',
        '    <div class="content-item-date">Monday, February 11, 2013 - <a href="http://www.peterbergstrom.com#thoughts/two-years-ago" title="permalink" target="_blank">[permalink]</a></div>',
        '    <div class="content-item-text">',
        '       <p>Two years ago today, on February 11th, 2011, I changed my life. First, I went out on a first date with Tracy, who is now my lovely wife after <a href="http://www.tracyandpeter.com" target="_blank">getting married on October 27th, 2012</a>. Second, that same day, was my last day Apple. Both of these events have shaped my life for the past two years and also, for the rest of my life.</p>',
        '       <p>When I was at Apple, I was stuck in an unhappy rut that I couldn’t get out of without doing something drastic. I liked working at Apple and it shaped who I am now in many ways, but I didn’t feel there was room for personal and career growth there. I was missing the “spark” that I had felt earlier and the only way for me to regain that was to take risks and get out of my comfort zone.</p>',
        '       <p>So, I took some risks and got out of my comfort zone. I asked my future wife out on a date and set out on a new adventure in my career. I’m very happy where I am now and super excited what the future will bring at home and at work.</p>',
        '       <p>Happy anniversary Tracy, I love you very much!</p>',
        '    </div>',
        ' </div>',
        ' <div class="content-item">',
        '    <h3 id="thoughts_some-thoughts-on-moving-to-ios-development">Some Thoughts On Moving To iOS Development</h3>',
        '    <div class="content-item-date">Wednesday, November 14, 2012 - <a href="http://www.peterbergstrom.com#thoughts/some-thoughts-on-moving-to-ios-development" title="permalink" target="_blank">[permalink]</a></div>',
        '    <div class="content-item-text">',
        '       <p>I’ve always been interested in pushing the limits of what can be done in a web browser and I’ve done that when I was at Apple, Strobe and now Groupon with <a href="http://www.sproutcore.com" target="_blank">SproutCore</a>&nbsp; and <a href="http://www.emberjs.com" target="_blank">Ember.js</a> as well as during working on <a href="http://papercube.peterbergstrom.com" target="_blank">research for the visualization academic citation networks</a> while at UC Santa Cruz and Santa Clara University.</p>',
        '       <p>I’ve made a switch that I’ve contemplated for quite some time. I’m leaving the web behind and entering the world of iOS development. I believe in the bright future of HTML 5 on mobile and I know that I’ve not left it behind forever but it’s nice to try something new. I have to say that I enjoy iOS development so far when I compare it HTML 5 application development with the above mentioned frameworks.</p>',
        '       <p>There are two major reasons. First, the never ending worries of browser and device compatibility is addressed by the iOS ecosystem. There is a very limited number of OS versions and devices. Since the number of potential variations is reduced, you can spend more time getting the user experience perfect. There are less compromises that have to decided on that gives users a variable experience based on their platform. That’s a great thing from the user interface design and development side.</p>',
        '       <p>Second, is that there a more stable and more importantly, more documented SDK in the iOS world. The Apple documentation is not perfect, but it’s much better than the state of the HTML 5 frameworks that I come from. I have to say, however, that it is mostly my own fault. Since the projects that I’ve worked on always strives to do new stuff, we are usually working with a framework that is not complete and as such, has no real documentation beyond the code itself. Over the years of developing client side web applications with SproutCore and Ember.js, I’ve always been on the bleeding edge and developing my apps as the frameworks were being written. Since the APIs for the frameworks were constantly changing, it is more of a challenge to write maintainable and well-organized code. Not impossible, but you have to understand the internals of the framework in order to do things right.</p>',
        '       <p>As a result, I’ve had to rely on the alpha or beta versions of supporting frameworks. I do this because the bleeding edge version of the framework has features that we need and some times, the changes in the frameworks are done to support the application I am working on. However, that leads to one unfortunate reality. I have to freeze the version of the framework regardless of where it is in its release cycle as I get close to releasing my own application because I can’t have things changing underneath me.</p>',
        '       <p>The downside of this is that once the framework does freeze its API and releases a solid point release (such as Ember 1.0), I’m in no position to easily port my application to support it because I have moved on to the next project. To go back and update to the latest stable version of a framework is very disruptive for the team and I’ve rarely seen it happening until we decide to do a major rewrite much later. Then, we usually fall in the same trap because the newer alpha or beta version of the framework, such as a 2.0 release, will have stuff we need at that future point. As a result, it’s a never ending cycle. I do have to say that I enjoy living on the edge of open source frameworks but it can also be frustrating because things change quickly.</p>',
        '       <p>With iOS development, things are very different to me as a developer because of the frequency of SDK releases and the documentation that comes with it. The API might break from major release to release, but there amount of churn is a lot less. So far, I’m enjoying that aspect of my journey as an iOS developer.</p>',
        '    </div>',
        ' </div>',
        ' <div class="content-item">',
        '    <h3 id="thoughts_back-to-the-crapper">My 24 Hours of LeMons Team, Back to the Crapper</h3>',
        '    <div class="content-item-date">Tuesday, February 21, 2012 - <a href="http://www.peterbergstrom.com#thoughts/back-to-the-crapper" title="permalink" target="_blank">[permalink]</a></div>',
        '    <div class="content-item-text">',
        '       <p>One of my friends has an old 1987 Toyota MR2 that we can use for <a href="http://www.24hoursoflemons.com" target="_blank">24 Hours of LeMons</a> that got it from a friend who was going to take it to the junk yard.</p>',
        '       <p>Check out  <a href="http://www.backtothecrapper.com" target="_blank">Back to the Crapper’s site</a> for more details. It should be fun. There are three races in California that we are thinking of checking out.</p>',
        '    </div>',
        ' </div>',
        ' <div class="content-item">',
        '    <h3 id="thoughts_joining-groupon">I’m joining Groupon</h3>',
        '    <div class="content-item-date">Wednesday, December 7, 2011 - <a href="http://www.peterbergstrom.com#thoughts/joining-groupon" title="permalink" target="_blank">[permalink]</a></div>',
        '    <div class="content-item-text">',
        '       <p>I think that my blog has become a place where I update where I’m working every now and then. I promise that will not be the case moving forward, if I can help it.</p>',
        '       <p>I’ve decided to join Groupon to lead a team working on their Scheduler application. Should be lots of fun!</p>',
        '    </div>',
        ' </div>',
        ' <div class="content-item">',
        '    <h3 id="thoughts_life-after-apple">Life after Apple</h3>',
        '    <div class="content-item-date">Saturday, June 11, 2011 - <a href="http://www.peterbergstrom.com#thoughts/life-after-apple" title="permalink" target="_blank">[permalink]</a></div>',
        '    <div class="content-item-text">',
        '       <p>I’ve been really busy and I’ve forgotten to post for a long time!</p>',
        '       <p>Anyway, the major change for me is that I’ve quit Apple to pursue the creation of future of the mobile applications at Strobe. I’m really excited about this new step in my life and career.</p>',
        '       <p>The best places to keep track of my work is on Twitter: <a href="http://twitter.com/#!/pbergstr">@pbergstr</a> and on GitHub: <a href="https://github.com/pbergstr" target="_blank">https://github.com/pbergstr</a></p>',
        '    </div>',
        ' </div>',
        ' <div class="content-item">',
        '    <h3 id="thoughts_papercube-open-sourced">PaperCube Open Sourced!</h3>',
        '    <div class="content-item-date">Tuesday, November 24, 2009 - <a href="http://www.peterbergstrom.com#thoughts/papercube-open-sourced" title="permalink" target="_blank">[permalink]</a></div>',
        '    <div class="content-item-text">',
        '       <p>PaperCube has been <a href="http://github.com/pbergstr/PaperCube">released as open source software under the MIT license on GitHub</a>. </p>',
        '       <p>For more information about the project, look at the wiki:<br><a href="http://wiki.github.com/pbergstr/PaperCube">http://wiki.github.com/pbergstr/PaperCube<br></a><br>To learn more about PaperCube, you can try it out at<br><a href="http://papercube.peterbergstrom.com">http://papercube.peterbergstrom.com</a>, view the demo video at <a href="http://vimeo.com/5661651">http://vimeo.com/5661651</a>. </p>',
        '       <p>If you want to read more about PaperCube and related research go to<br><a href="http://www.peterbergstrom.com/research/">http://www.peterbergstrom.com/research/</a></p>',
        '       <p>There is code reference documentation for PaperCube and the NodeGraph<br>framework at <a href="http://www.peterbergstrom.com/papercube_docs/">http://www.peterbergstrom.com/papercube_docs/</a> and<br><a href="http://www.peterbergstrom.com/nodegraph_docs/">http://www.peterbergstrom.com/nodegraph_docs/</a>, respectively.</p>',
        '       <p>In related news, I want to also highlight that the research that spawned PaperCube has lead to <a href="http://www.peterbergstrom.com/peter_bergstrom_scu_thesis.pdf"> my Master’s thesis</a> and two papers. First, <a href="http://svgopen.com/2009/papers/19-Digital_Library_Visualization_Using_SproutCore_and_SVG/">Digital Library Visualization Using SproutCore and SVG</a>, presented at <a href="http://www.svgopen.org">SVG Open 2009</a>. Second, <a href="http://www.peterbergstrom.com/bergstrom_atkinson_icdim.pdf">Augmenting the Exploration of Digital Libraries with Web-Based Visualizations</a>, presented at <a href="http://www.icdim.org">ICDIM 2009</a>.</p>',
        '    </div>',
        ' </div>',
        ' <div class="content-item">',
        '    <h3 id="thoughts_papercube-introduction-video">PaperCube Introduction Video</h3>',
        '    <div class="content-item-date">Sunday, February 22, 2009 - <a href="http://www.peterbergstrom.com#thoughts/papercube-introduction-video" title="permalink" target="_blank">[permalink]</a></div>',
        '    <div class="content-item-text">',
        '       <p>',
        '         <iframe src="http://player.vimeo.com/video/3323956" width="640" height="360" style="border: none"></iframe>',
        '         <br><a href="http://vimeo.com/3323956">Introduction to PaperCube</a> from <a href="http://vimeo.com/user1334730">Peter Bergström</a> on <a href="http://vimeo.com">Vimeo</a>.',
        '       </p>',
        '       <p>PaperCube demo: <a href="http://papercube.peterbergstrom.com">http://papercube.peterbergstrom.com</a></p>',
        '       <p>This is an introduction to my MS thesis research into the visualization of digital libraries.</p>',
        '       <p>Demo mirror: <a href="http://concerto.engr.scu.edu/~pbergstr">http://concerto.engr.scu.edu/~pbergstr</a></p>',
        '    </div>',
        ' </div>',
        ' <div class="content-item">',
        '    <h3 id="thoughts_papercube-update">PaperCube Introduction Video</a>PaperCube Update</h3>',
        '    <div class="content-item-date">Monday, February 16, 2009 - <a href="http://www.peterbergstrom.com#thoughts/papercube-update" title="permalink" target="_blank">[permalink]</a></div>',
        '    <div class="content-item-text">',
        '       <p>I’ve updated PaperCube to what I hope to be the final version that now allows you to view papers as well as authors. I’m really excited and I hope that people will find it interesting. I’ll follow this up with a detailed post in the next couple of weeks.</p>',
        '       <p>In the mean time, you can still check out the feature complete version of <a href="http://papercube.peterbergstrom.com">PaperCube</a>.</p>',
        '       <p>Please note that it is experimental so there will be bugs. :)</p>',
        '       <h2>SVG-Based View: Collaborators</h2>',
        '       <p>You can view an author’s collaborators dynamically using a graph. This graph can be tweaked in many ways in real time to reveal more or less data depending on many different parameters:</p>',
        '       <p><img src="http://www.peterbergstrom.com/images/papercube/collabs.jpg" alt="Collaborator View"></p>',
        '    </div>',
        ' </div>',
        ' <div class="content-item">',
        '    <h3 id="thoughts_papercube">PaperCube</h3>',
        '    <div class="content-item-date">Friday, November 14, 2008 - <a href="http://www.peterbergstrom.com#thoughts/papercube" title="permalink" target="_blank">[permalink]</a></div>',
        '    <div class="content-item-text">',
        '       <div style="float: right; width: 25%; height:auto;"><img style="border: 0px; width:100%; height:auto;" src="http://www.peterbergstrom.com/images/papercube/full_medium.png" alt="PaperCube logo."></div>',
        '       <div style="float: left; width: 70%;">',
        '          <p>For the last 3 months, I’ve been working hard on my Master’s thesis project at Santa Clara University, code-named PaperCube. It is a rich internet application using <a href="http://www.sproutcore.com" target="_blank">SproutCore</a>, SVG, and the canvas tag. For even more interactivity, I use Webkit CSS transitions for animation. No Flash, Flex, or Silverlight.</p>',
        '          <p>The name <em>PaperCube</em> may sound a bit odd. If you’re familiar with my research topic, the first part makes sense since I’m researching ways to more effectively search digital libraries with a focus on academic paper network navigation. The second part isn’t as clear, even to me. I want to show many different dimensions of the data and that’s why I thought of a cube. I’m finally to a point where it is useable and relatively stable. Therefore, it has escaped my laptop to be hosted on an actual web server.</p>',
        '          <p><a href="http://papercube.peterbergstrom.com" target="_blank">Try PaperCube</a> (opens in a new window)</p>',
        '       </div>',
        '       <h2 style="padding-top:10px; clear:both">What data can you search and view?</h2>',
        '       <p>PaperCube now allows you to search papers in the <a href="http://citseerx.ist.psu.edu" target="_blank">CiteSeer</a> digital library. The data that you can browse using PaperCube contains papers, references, authors, and affiliations; all elements of a typical digital library. There are a lot of digital libraries online such as the ACM Digital Library and IEEE Xplore. However, they are not available unless you’re a subscriber to the service and there are many intellectual property concerns.</p>',
        '       <p>Fortunately, Penn State University maintains CiteSeer. CiteSeer is an open digital library containing more than 1 million papers. The data set is available to download in XML format. Unfortunately, the downloadable data set is from. Some issues that are causing problems is that papers do not have all their references in the data set, the publication date of papers is incorrect, and authors are not uniquely identified. It is still a very good data set and it is quite useable, but it isn’t perfect. However, there is hope for perfection because there is a new version called CiteSeerX that I really hope to be able to use eventually if it is made available for download.</p>',
        '       <h2 style="padding-top:10px;">Searching</h2>',
        '       <div style="float: left; width:70%;">PaperCube allows you to search papers and authors. (Authors are not yet fully implemented). To find papers papers, you can search against the title, abstract, publication year, publisher, author name, affiliation, and address. To reveal the search pane, put your cursor to the left side of the window and it will be revealed. Click on any of the papers, the more references and citations, the better, of course. For example, searching paper titles containing the term “hypertext” will return more than 500 papers. If you click on the screenshot on the left, you can see the search pane in action.</div>',
        '       <div style="float: right; width: 25%; height: auto;"><img style="cursor:pointer;width:100%; height:auto;" onclick="javascript:window.open(\'images/papercube/papercube_screens/search_large.png\')" src="http://www.peterbergstrom.com/images/papercube/papercube_screens/search_small.png" alt="Search Pane Screenshot"><br><span style="font-size: 9px;">search interface</span></div>',
        '       <h2 style="clear:both; padding-top:20px;">A walk along the tool bar</h2>',
        '       <div style="float: right; width:70%;">',
        '          <p>PaperCube keeps your browsing history as you browse and search papers. It works behaves in the same way as your browser history. If you press down on the button for more than half a second, you’ll see a menu list of your visited papers that you can select from. Also, when you switch views, a history item will be added.</p>',
        '          <p>Next, there is the “Mode” drop down menu. You can either view papers or authors. Further to the right, there is the “View” menu. When you switch the “Mode”, the “View” menu will change accordingly. The “View” menu allows you to select one of the many views of a paper. I’ll describe each one in a bit more detail later.</p>',
        '          <p>Moving further to the right, next there is the “Direction” menu. You can either view references or citations. The distinction may seem confusing. I want to be able to show relationships of papers in two directions. Thus, in my language, paper A <em>references</em> paper B, and paper B is <em>cited</em> by A. Also, some views will also have a menu for “Max Iterations”. Some of the views recursively explore the citation network of a paper and there are cases when you want to limit the amount of papers retrieved. I’ve gone as far as retrieving 37,000 papers. Imagine showing that on your screen!</p>',
        '          <p>Finally, on the right side of the screen there is a slider. This slider allows you to scale the visualization. All visualizations have different levels of zoom. For instance, Papers Per Year view allows you to zoom in 20 times. When you zoom in, you will see a small preview window that you can move around the visible area. You can also scroll zoom using your mouse. The zooming capability was basically the first thing that I worked on when I started because I know that being resolution independent is very important in some views. If you can infinitely reveal more information as you zoom in further, the possibilities are endless.</p>',
        '       </div>',
        '       <div style="float: left; width: 25%; height: auto;"><img style="margin-top:10px; cursor:pointer; width:100%; height:auto;" onclick="javascript:window.open(\'images/papercube/papercube_screens/history1_large.png\')" src="http://www.peterbergstrom.com/images/papercube/papercube_screens/history1_small.png" alt="History Menu Screenshot"><br><span style="font-size: 9px;">history menu</span><br><img style=" width:100%; height:auto;cursor:pointer; margin-top:10px" onclick="javascript:window.open(\'images/papercube/papercube_screens/menu_large.png\')" src="http://www.peterbergstrom.com/images/papercube/papercube_screens/menu_small.png" alt="View Menu Screenshot"><br><span style="font-size: 9px;">view menu</span><br><img style="cursor:pointer; margin-top:10px; width:100%; height:auto;" onclick="javascript:window.open(\'images/papercube/papercube_screens/zoom_large.png\')" src="http://www.peterbergstrom.com/images/papercube/papercube_screens/zoom_small.png" alt="Zoom Menu Screenshot"><br><span style="font-size: 9px;">zoom menu</span></div>',
        '       <h2 style="clear:both; padding-top:20px">The real reason for PaperCube: the views</h2>',
        '       <p>All the views are interconnected with each other. If you change the “View” in the tool bar, you will change the view, but not what paper is being shown, an advantage of using a MVC framework like SproutCore. Some of the views use a “fan” menu to aid navigation. When you click on an element on the screen, the menu will be revealed where you can perform several different actions including zooming, navigating to other papers, and loading the paper on CiteSeer’s web site.</p>',
        '       <h3>Detail View</h3>',
        '       <p>First, there is “Detail”, this is more of a traditional web-based digital library view of a paper. If you mouse-over any of the references or citations, you will see more details about that paper. The reference/citation graph shows the frequency of papers per year.</p>',
        '       <div style="width: 100%; height: 100px;">',
        '          <div style="float: left; margin-left:10% "><img style="cursor:pointer; width:100%; height: auto; " onclick="javascript:window.open(\'images/papercube/papercube_screens/detail1_large.png\')" src="http://www.peterbergstrom.com/images/papercube/papercube_screens/detail1_small.png" alt="Detail View Screenshot"><br><span style="font-size: 9px;">details of a paper</span></div>',
        '          <div style="float: right; margin-right:10%"><img style="cursor:pointer; " onclick="javascript:window.open(\'images/papercube/papercube_screens/detail2_large.png\')" src="http://www.peterbergstrom.com/images/papercube/papercube_screens/detail2_small.png" alt="Detail View Screenshot"><br><span style="font-size: 9px;">showing citation additional info</span></div>',
        '       </div>',
        '       <h3 style="clear:both; margin-top: 20px">Circle View</h3>',
        '       <p>Second, there is “Circle View”. A simple version of Circle View was originally developed in 2004 as part of my undergraduate thesis at UC Santa Cruz. This visualization shows paper and two levels of references or citations. The color of the lines signifies the number of citations that a paper has. The theory is that the number of times a paper is cited can imply importance. One neat feature of Circle View is that papers can be displayed more than once. For example, if there is a paper that is referenced 3 times by papers in the visible area, the paper will be highlighted in all three places allowing you to quickly see if it may be important. This actually has some cognitive psychology theory behind it using the feature-present/feature-absent effect. Things that stand out are very easy to count. This is used in other visualizations as well.</p>',
        '       <div style="width: 100%; height: 100px">',
        '          <div style="float: left; margin-left:5% width: 25%;height: auto;"><img style="cursor:pointer; width: 100%; height: auto " onclick="javascript:window.open(\'images/papercube/papercube_screens/circleview1_large.png\')" src="http://www.peterbergstrom.com/images/papercube/papercube_screens/circleview1_small.png" alt="Circle View Screenshot"><br><span style="font-size: 9px;">circle view showing meta data</span></div>',
        '          <div style="float: left; margin-left:5%;width: 25%;height: auto;"><img style="cursor:pointer; width: 100%; height: auto " onclick="javascript:window.open(\'images/papercube/papercube_screens/circleview2_large.png\')" src="http://www.peterbergstrom.com/images/papercube/papercube_screens/circleview2_small.png" alt="Circle View Screenshot"><br><span style="font-size: 9px;">zoomed in</span></div>',
        '          <div style="float: left; margin-left:5%;width: 25%;height: auto;"><img style="cursor:pointer;  width: 100%; height: auto" onclick="javascript:window.open(\'images/papercube/papercube_screens/circleview3_large.png\')" src="http://www.peterbergstrom.com/images/papercube/papercube_screens/circleview3_small.png" alt="Circle View Screenshot"><br><span style="font-size: 9px;">showing the fan menu</span></div>',
        '       </div>',
        '       <h3 style="clear:both; margin-top: 20px">Tree Map</h3>',
        '       <p>Third, there is the “Tree Map” view. It is not necessarily a traditional tree map that you see for things such as showing disk usage. This visualization shows levels of citations or references. In the case of references, the focused paper is on top. For citation, the focused paper is shown on the bottom. Basically, each level of the map shows one more reference hop away from the focused paper. A paper’s references or citations is contain within the width of it’s parent. This means that at the end, the papers will become thinner and thinner. However, you can reveal more information by zooming in. A red box in the tree means that the width of the references is smaller than 0.1 pixels and it’s not worth showing. By zooming in, you will be able to see that information and it will be requested from the server as needed.</p>',
        '       <div style="width: 100%; height: 100px">',
        '          <div style="float: left; margin-left:10%"><img style="cursor:pointer; " onclick="javascript:window.open(\'images/papercube/papercube_screens/tree1_large.png\')" src="http://www.peterbergstrom.com/images/papercube/papercube_screens/tree1_small.png" alt="Tree Map Screenshot"><br><span style="font-size: 9px;">tree map view</span></div>',
        '          <div style="float: right; margin-right:10%"><img style="cursor:pointer; " onclick="javascript:window.open(\'images/papercube/papercube_screens/tree2_large.png\')" src="http://www.peterbergstrom.com/images/papercube/papercube_screens/tree2_small.png" alt="Tree Map Screenshot"><br><span style="font-size: 9px;">zoomed in to reveal more papers</span></div>',
        '       </div>',
        '       <h3 style="clear:both; margin-top: 20px">Papers Per Year</h3>',
        '       <p>Last, there is “Per Year” view. This is kind of similar to the tree map but papers are ordered by year. The focused paper is shown on the top separately and it’s references are interspersed throughout the years. You can specify the number of recursions to perform. The more you do, the more complete your picture of the paper’s citation network will be, but it can be dangerous for your browser’s health because there is the potential to retrieve a lot of data. When you mouse over a paper with references or citations that are downloaded (You can download more by upping the levels), you will see lines linking other papers. A blue line means that it is a reference. A red line means that it is a citation. You can pin the lines by clicking on a paper and using the menu.</p>',
        '       <div style="width: 100%; height: 100px">',
        '          <div style="float: left; margin-left:5% width: 25%; height: auto"><img style="cursor:pointer; width: auto; height: auto " onclick="javascript:window.open(\'images/papercube/papercube_screens/peryear1_large.png\')" src="http://www.peterbergstrom.com/images/papercube/papercube_screens/peryear1_small.png" alt="Papers Per Year Screenshot"><br><span style="font-size: 9px;">papers per year view</span></div>',
        '          <div style="float: left; margin-left:5%; width: 25%; height: auto"><img style="cursor:pointer;  width: 100%; height: auto" onclick="javascript:window.open(\'images/papercube/papercube_screens/peryear2_large.png\')" src="http://www.peterbergstrom.com/images/papercube/papercube_screens/peryear2_small.png" alt="Papers Per Year Screenshot"><br><span style="font-size: 9px;">showing both ref and cites</span></div>',
        '          <div style="float: left; margin-left:5%; width: 25%; height: auto"><img style="cursor:pointer;  width: 100%; height: auto" onclick="javascript:window.open(\'images/papercube/papercube_screens/peryear3_large.png\')" src="http://www.peterbergstrom.com/images/papercube/papercube_screens/peryear3_small.png" alt="Papers Per Year Screenshot"><br><span style="font-size: 9px;">papers per year view zoomed in</span></div>',
        '       </div>',
        '       <h2 style="clear:both; margin-top: 20px">Conclusion</h2>',
        '       <p>There’s still a lot of work to do. I am going to implement the author component of the application next. There are a lot of other visualizations that I want to explore if I have time for both papers and authors. PaperCube works best in Webkit. Webkit with SquirrelFish and CSS transitions makes PaperCube really rock. However, using Firefox 3 works just as well. Internet Explorer is just too slow to do any of the things that I’m doing. Also, I use SVG and the canvas tag, both of which are not natively supported on IE. I use SproutCore as the application framework to enable a lot of the rich application interaction.</p>',
        '       <p>If you have any comments, suggestions for new views or features, questions, and especially bugs to report, please don’t hesitate to email me at <strong>pbergstr</strong> at <strong>me</strong> dot <strong>com</strong> or hit me up on the <a href="http://www.peterbergstrom.com/contact/">contact</a> page.</p>',
        '    </div>',
        ' </div>',
        '</div>'
     ],
     research:[
        '<h1 class="site-content-main-title">Research Publications</h1>',
        '<div class="content-item">',
        '   <div class="content-item-date"></div>',
        '   <div class="content-item-text">',
        '      <p>P. Bergström, M. Chan, M. Dale, and E. James Whitehead, Jr. Sapphire: Composite Hypertext Document Structures. Poster in <em>Proceedings of the 15th ACM Conference on Hypertext and Hypermedia</em>, August 9-13, 2004, Santa Cruz, California, USA. <a target="_blank" href="http://www.peterbergstrom.com/files/bergstrom_sapphire.pdf">[PDF]</a></p>',
        '      <p>P. Bergström. Circleview: Scalable visualization and navigation of citation networks. <em>Undergraduate thesis</em>, School of Engineering, University of California at Santa Cruz, Santa Cruz, California, USA. December 2004.</p>',
        '      <p>P. Bergström and E. J. Whitehead. Jr. Circleview: Scalable visualization and navigation of citation networks. In <em>Proceedings of the 2006 Symposium on Interactive Visual Information Collections and Activity</em>, June 19, 2006, College Station, Texas, USA. <a target="_blank" href="http://www.peterbergstrom.com/files/L1-2-BergstromWhitehead.pdf">[PDF]</a></p>',
        '      <p>P. Bergström. Augmenting digital libraries using web-based visualizations. <em>Master’s thesis</em>, Santa Clara University, Department of Computer Engineering, Santa Clara, California, USA. June 24, 2009. <a target="_blank" href="http://www.peterbergstrom.com/peter_bergstrom_scu_thesis.pdf">[PDF]</a></p>',
        '      <p>P. Bergström and D. C. Atkinson. Digital Library Visualization Using SproutCore and SVG. In <em>Proceedings of the Seventh International Conference on Scalable Vector Graphics</em>, October 2-4, 2009, Mountain View, California, USA. <a target="_blank" href="http://svgopen.com/2009/papers/19-Digital_Library_Visualization_Using_SproutCore_and_SVG/">[HTML]</a></p>',
        '      <p>P. Bergström and D. C. Atkinson. Augmenting the Exploration of Digital Libraries with Web-Based Visualizations. In <em>Proceedings of the Fourth International Conference on Digital Information Management</em>, November 2-4, 2009, Ann Arbor, Michigan, USA. <a target="_blank" href="http://www.peterbergstrom.com/bergstrom_atkinson_icdim.pdf">[PDF]</a></p>',
        '      <h1>Master’s Research</h1>',
        '      <h2>PaperCube Demo</h2>',
        '      <iframe src="http://player.vimeo.com/video/5661651" width="400" height="225" style="border: none"></iframe>',
        '      <p><a target="_blank" href="http://vimeo.com/5661651">Introduction to PaperCube Beta</a>from <a target="_blank" href="http://vimeo.com/user1334730">Peter Bergström</a> on <a target="_blank" href="http://vimeo.com">Vimeo</a>.</p>',
        '      <h2>Thesis Abstract</h2>',
        '      <p>The main goal of my research was two-fold. First, to develop and test the effectiveness of an application that can augment a scholar’s interaction with a digital library and explore bibliographic meta data using a defined set of visualizations. These visualizations needed to provide different levels of visibility into a paper’s citation network without losing focus of the currently viewed paper. The application, called PaperCube, needed to support navigation between papers and, to a limited extent, the authors of those papers. The application needed to be able to provide insight into author to author citation networks as well as collaboration relationships.</p>',
        '      <p>The hypothesis was that by replacing the traditional webpage-based paradigm with a suite of visualizations that expose various dimensions of bibliographic meta data, the a researcher could gain new insights and find relationships that were not previously apparent. Furthermore, by making the experience spatial, the aim was to see if researchers were able to find what they were looking for more quickly and intuitively.</p>',
        '      <p>The second goal was to push the limits of modern web browsers. By using web standards-based technologies, the goal was to explore the possibility of creating a dynamic, desktop-like experience that incorporates rich, interactive visualizations.</p>',
        '      <p>PaperCube was written using the SproutCore JavaScript framework, which is geared towards the creation of highly interactive, cloud, or thick-client applications in the web browser. Using only JavaScript and standards-based rendering technologies such as Scalable Vector Graphics, Canvas tag, HTML and CSS, PaperCube allows users to browse a version of the CiteSeer digital library and view paper and author relationships using a set of dynamic visualizations.</p>',
        '      <p>Leveraging the powerful features in SproutCore including bindings and observers, PaperCube aims to deliver unparalleled interactivity within the confines of a web browser. Bindings and observers enabled PaperCube to easily implement resolution independence in its visualizations. Resolution independence was key because citation networks can be very large. By adjusting a slider control in the UI, a visualization can be zoomed in using vector-based transforms without needing to explicitly redraw. Furthermore, through the use of bindings, slider controls can dynamically alter the display parameters of the visualizations, permitting the depth of a paper citation network to be adjusted or the thresholds that determine if a node should be displayed as part of the graph changed.</p>',
        '      <p>Stemming from the need for a flexible graph API for various views in PaperCube, the SVG-based NodeGraph class was created as a generalized solution that can display any type of relational data as an undirected graph. The class is not PaperCube-specific and could be easily integrated into other applications.</p>',
        '      <p>PaperCube was validated through a user study which showed that it was very useful when it comes to augmenting digital library search by reducing the “cognitive load” put on a scholar and aiding the “discoverability” of new research material. Furthermore, it was shown that participants thought that it was “visually exciting and intuitive” application and an “amazing example of the apps that well be seeing on the web in a couple of years.”</p>',
        '      <h2>Related Publications</h2>',
        '      <p></p>',
        '      <p>P. Bergström. Augmenting digital libraries using web-based visualizations. <em>Master’s thesis</em>, Santa Clara University, Department of Computer Engineering, Santa Clara, California, USA. June 24, 2009. <a target="_blank" href="http://www.peterbergstrom.com/peter_bergstrom_scu_thesis.pdf">[PDF]</a></p>',
        '      <p>P. Bergström and D. C. Atkinson. Digital Library Visualization Using SproutCore and SVG. In <em>Proceedings of the Seventh International Conference on Scalable Vector Graphics</em>, October 2-4, 2009, Mountain View, California, USA. <a target="_blank" href="http://svgopen.com/2009/papers/19-Digital_Library_Visualization_Using_SproutCore_and_SVG/">[HTML]</a></p>',
        '      <p>P. Bergström and D. C. Atkinson. Augmenting the Exploration of Digital Libraries with Web-Based Visualizations. In <em>Proceedings of the Fourth International Conference on Digital Information Management</em>, November 2-4, 2009, Ann Arbor, Michigan, USA. <a target="_blank" href="http://www.peterbergstrom.com/bergstrom_atkinson_icdim.pdf">[PDF]</a></p>',
        '      <h1>Undergraduate Research</h1>',
        '      <p>I have conducted two research projects as an undergraduate at the University of California at Santa Cruz. Below you can read the abstracts for both papers, download their PDFs, <del datetime="2007-06-04T05:27:18+00:00">as well as access online demos of the two projects.</del> (Demos will be forthcoming on the new site.)</p>',
        '      <h2>CircleView</h2>',
        '      <p>CircleView is a citation network browser that uses circles around circles as its visualization method to show a focus paper and two levels of its citation network. This method scales to varying numbers of papers and references, and has a structured layout that makes the visualization more readable. Bibliographic metadata is available via mouseover for all displayed papers. General requirements are presented for citation network visualization and navigation tools. An important requirement is the ability to integrate with existing institutional digital libraries, satisfied by CircleView’s use of web browser facilities for its user interface. CircleView is shown to have good visualization and performance scalability characteristics.</p>',
        '      <p>Published at the <a target="_blank" href="http://www.eastgate.com/catalog/HT04.html">2004 ACM Conference on Hypertext and Hypermedia</a> as a poster.</p>',
        '      <h3>Related Publications</h3>',
        '      <p>P. Bergström. Circleview: Scalable visualization and navigation of citation networks. <em>Undergraduate thesis</em>, School of Engineering, University of California at Santa Cruz, Santa Cruz, California, USA. December 2004.</p>',
        '      <p>P. Bergström and E. J. Whitehead. Jr. Circleview: Scalable visualization and navigation of citation networks. In <em>Proceedings of the 2006 Symposium on Interactive Visual Information Collections and Activity</em>, June 19, 2006, College Station, Texas, USA. <a target="_blank" href="http://www.peterbergstrom.com/files/L1-2-BergstromWhitehead.pdf">[PDF]</a></p>',
        '      <h3>Sapphire</h3>',
        '      <p>Inspired by Theodor Nelson’s Xanadu and vLit concepts,  Sapphire implements a composite document structure in which  formatting is specified external to the text. Formatting overlays  are rendered over the text, so multiple overlays may be stacked  according to user preference. Sapphire supports the viewing of a  document composed from multiple fragments, and viewing the  original source of each fragment. Other features include  annotation on the composite documents and the storing and  restoring of document trails in the spirit of the Memex. An editor  function permits the creation and editing of Sapphire composite  documents. This project served as an exploration of the potential  of alternative hypertext implementations to the pervasive HTML  standard in use today.</p>',
        '      <h3>Related Publications</h3>',
        '      <p>P. Bergström, M. Chan, M. Dale, and E. James Whitehead, Jr. Sapphire: Composite Hypertext Document Structures. Poster in <em>Proceedings of the 15th ACM Conference on Hypertext and Hypermedia</em>, August 9-13, 2004, Santa Cruz, California, USA. <a target="_blank" href="http://www.peterbergstrom.com/files/bergstrom_sapphire.pdf">[PDF]</a></p>',
        '   </div>',
        '</div>'
     ]
  }
};

